package com.teamo.biom.hub;
// ----- Controller Class -----
    // Contains Variables and Methods to control which Threads to run.
public class Controller extends Thread
{
    // Non-Thread Objects
        AppServer appServer = null;

        // Thread Objects
        // SerialCommunicator.Connector serialConnector;
        //     ProcessTimer serialConnectorTimer = new ProcessTimer( 5000 );

        WifiChecker wifiChecker = null;
            ProcessTimer wifiCheckerTimer = new ProcessTimer( 10000 );

        // SerialCommunicator.HubCaller hubCaller = null;
        //     ProcessTimer hubcallTimer = new ProcessTimer( 5000 );

        AppFinder appFinder = null;

        AppServer.Connector appServerConnector = null;

        ModuleList moduleList = new ModuleList();
            ModuleList.Cleaner moduleCleaner = null;
                ProcessTimer moduleCleanerTimer = new ProcessTimer( 15000 );

    public void run()
    {
        System.out.println( "Controller: Initiating Setup Stage." );

        // Program Setup Step Sequence
            // Check Wifi Connection
            //wifiChecker = new WifiChecker();
            //wifiChecker.start();

        // Open Serial Port
            // serialConnector = serialCommunicator.new Connector();
            // serialConnector.start();
            //     // Initiate First HUBCALL
            //         hubCaller = serialCommunicator.new HubCaller();
            //         hubCaller.start();

        System.out.println( "Controller: Setup Stage complete. HUB is now running." );

        Controller.updateWIFI( true );

        // Controller Main Loop
        Thread terminator = null;
        while ( true )
        {
            ProcessTimer.updateMS();

            // Timed Single Run Threads
                // if ( wifiCheckerTimer.waitFor() )               // CHECK FOR WIFI CONNECTION
                // {
                //     wifiChecker = new WifiChecker();
                //     wifiChecker.start();
                // }

                // if ( hubcallTimer.waitFor() )                   // ATTEMPT TO SEND OUT HUBCALL
                // {
                //     hubCaller = serialCommunicator.new HubCaller();
                //     hubCaller.start();
                // }

                if ( moduleCleanerTimer.waitFor() )                   // ATTEMPT TO SEND OUT HUBCALL
                {
                    moduleCleaner = moduleList.new Cleaner();
                    moduleCleaner.start();
                }

            // Continuous Thread Control
                // if ( serialConnectorTimer.waitFor() )
                // {
                //     serialConnector = serialCommunicator.new Connector();
                //     serialConnector.start();
                // }
        
                // if ( Controller.isWIFIConnected() )
                // {
                //     if ( Controller.isUDPOnline() != true )     // ATTEMPT TO START UDP SERVICES
                //     {
                //         appFinder = new AppFinder();
                //         appFinder.start();
                //     }

                    if ( Controller.isTCPOnline() != true )     // ATTEMPT TO START TCP SERVICES
                    {
                        appServer = new AppServer();
                        if ( Controller.isTCPOnline() )
                        {
                            appServerConnector = appServer.new Connector();
                            appServerConnector.start();
                        }
                        else
                        {
                            if ( appServerConnector != null )
                            {
                                terminator = appServerConnector;
                                appServerConnector = null;
                                terminator.interrupt();
                            }
                        }
                    }
                // }
                // else        // TERMINATE ALL WIFI BASED SERVICES
                // {
                //     if ( appFinder != null ) 
                //     {
                //         terminator = appFinder;
                //         appFinder = null;
                //         terminator.interrupt();
                //     }

                // }
        }
    }

    // Control Variables
    static boolean  serialConnected,
                    wifiConnected,
                    udpOnline,
                    tcpOnline;

    // Read Control Methods
        static boolean isSerialConnected()
        {
            return serialConnected;
        }
        static boolean isWIFIConnected()
        {
            return wifiConnected;
        }
        static boolean isUDPOnline()
        {
            return udpOnline;
        }
        static boolean isTCPOnline()
        {
            return tcpOnline;
        }

    // Set Control Methods
        static void updateSerial( boolean bool )
        {
            serialConnected = bool;
        }
        static void updateWIFI( boolean bool )
        {
            wifiConnected = bool;
        }
        static void updateUDP( boolean bool )
        {
            udpOnline = bool;
        }
        static void updateTCP( boolean bool )
        {
            tcpOnline = bool;
        }
}