// CLASS IS NOT USED IN PRESENTATION / DEMO VERSION ( unnecessary, for home appliances only )
//
// Creative Technology, Module 2: Smart Environments
// Final Project, Team O
// Code by Zino J. Vieth
// "HUB Server"-Application (for Raspberry PI with Java SE Runtime)
//
// "WifiChecker"-Class (contains process of main())
// Pings www.google.com to check whether the HUB is connected to the internet or not.
// Updates Controller accordingly.
//  run method  :   main process method     :   called by main() depending on ProcessTimer
package com.teamo.biom.hub;
// ----- Imported Libraries -----
import java.util.ArrayList;     // ArrayList Class for cmdList<String>
import java.io.*;               // Input/Output Library

public class WifiChecker extends Thread
{

    // ----- Main Process Method -----
    public void run()
    {
        System.out.println( "WifiChecker: Checking for Wifi-Connection." );

        // Controller Update Variable
            boolean online = false;

        try {
            // Prepare Command Line
                ArrayList<String> cmdList = new ArrayList<String>();
                cmdList.add( "ping" );
                cmdList.add( "www.google.com" );

            // Prepare Process
                ProcessBuilder build = new ProcessBuilder( cmdList );

            // Start Process
                Process p = build.start();

            // Prepare Input Streams for Output and Error
                BufferedReader in = new BufferedReader(
                                        new InputStreamReader(
                                            p.getInputStream() ) );
                BufferedReader err = new BufferedReader(
                                        new InputStreamReader(
                                            p.getErrorStream() ) );

            // Read and print Output to Terminal / Update Controller Variable accordingly
                while ( in.readLine() != null )
                {
                    online = true;
                }
                while ( err.readLine() != null )
                {
                    online = false;
                }

        } catch ( IOException e ) {
            System.out.println( "WifiChecker: An error occured during the ping process." );
            System.out.println( e.getMessage() );
        }

        if (online) { System.out.println( "WifiChecker: Wifi is online." ); }
        else { System.out.println( "WifiChecker: Wifi is offline." ); }

        // Pass result to Controller
            Controller.updateWIFI( online );
    }

}

// Resources:
//  https://www.geeksforgeeks.org/pinging-ip-address-java-set-2by-creating-sub-process/